import birl.{type Time}
import gleam/dynamic/decode.{type Decoder}

pub fn datetime_decoder() -> Decoder(Time) {
  use value <- decode.then(decode.string)
  case birl.parse(value) {
    Ok(time) -> decode.success(time)
    Error(Nil) -> decode.failure(birl.now(), "DateTime")
  }
}

pub fn date_decoder() -> Decoder(Time) {
  use value <- decode.then(decode.string)
  case birl.from_naive(value) {
    Ok(time) -> decode.success(time)
    Error(Nil) -> decode.failure(birl.now(), "Date")
  }
}
